现在的位置: 首页 > 综合 > 正文

HDU 3661 Assignments 贪心排序

2018年05月02日 ⁄ 综合 ⁄ 共 1934字 ⁄ 字号 评论关闭

Assignments

Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 1553    Accepted Submission(s): 715

Problem Description
In a factory, there are N workers to finish two types of tasks (A and B). Each type has N tasks. Each task of type A needs xi time to finish, and each task of type B needs yj time to finish, now, you, as the boss of the factory, need
to make an assignment, which makes sure that every worker could get two tasks, one in type A and one in type B, and, what's more, every worker should have task to work with and every task has to be assigned. However, you need to pay extra money to workers
who work over the standard working hours, according to the company's rule. The calculation method is described as follow: if someone’ working hour t is more than the standard working hour T, you should pay t-T to him. As a thrifty boss, you want know the minimum
total of overtime pay.
 

Input
There are multiple test cases, in each test case there are 3 lines. First line there are two positive Integers, N (N<=1000) and T (T<=1000), indicating N workers, N task-A and N task-B, standard working hour T. Each of the next two
lines has N positive Integers; the first line indicates the needed time for task A1, A2…An (Ai<=1000), and the second line is for B1, B2…Bn (Bi<=1000).
 

Output
For each test case output the minimum Overtime wages by an integer in one line.
 

Sample Input
2 5 4 2 3 5
 

Sample Output
4
/*
HDOJ 3661 贪心排序
题目大意是:有n个工人,有n种a任务,n种b任务,每个工人必然会完成一种a任务,一种b任务,
其中给n种a,b任务的不同时间,给出一种标准时间T,分配给工人一个ai,和bj任务,
如果ai+bj>标准时间T,则需要ai+bj-T的钱,
问怎样分配这a类任务和b类任务给每一个工人,使得工厂付的钱最少,求最少付多少钱。

用贪心,具体做法如下:
将a、b两种任务分别存在两个数组中,然后分别排序,一个从小到大另一个从大到小排。

因为我们可以假设当先取a中最小值时,将其与b中的最大值匹配一定不会亏,
因为若与b中最大值匹配时间超过了T,这a中任何一个与之匹配都会超,
若未超过,那自然最好。 
*/
#include<iostream>
#include<stdio.h>
#include<algorithm>
using namespace std;

int a[1001],b[1001];

bool cmp1(int a,int b)
{
	return a>b;
}

bool cmp2(int a,int b)
{
	return a<b;
}

int main()
{
	int i,n,t,ans;
	
	//freopen("test.txt","r",stdin);
	while(scanf("%d%d",&n,&t)!=EOF)
	{
		for(i=0;i<n;i++)
			scanf("%d",&a[i]);
		for(i=0;i<n;i++)
			scanf("%d",&b[i]);
		sort(a,a+n,cmp1);
		sort(b,b+n,cmp2);
		ans=0;
		for(i=0;i<n;i++)
		{
			if(a[i]+b[i]>t)
				ans+=a[i]+b[i]-t;
		}
		printf("%d\n",ans);
	}
	return 0;
}

抱歉!评论已关闭.